<script setup lang="ts">
import { useWhichDepartmentStore } from '@/stores/whichDepartmentStore';
import { useGameStore } from '@/stores/gameStore';
import { ref } from 'vue';
import type { Answer } from '@/types/Answer';
import WhichDepartmentView from './WhichDepartmentView.vue';

const whichDepartmentStore = useWhichDepartmentStore();
const gameStore = useGameStore();
const person = whichDepartmentStore.person;
const answers = ref(whichDepartmentStore.answers);
let showPlusOne = ref(false);
let completed = ref(false);

function onAnswerClick(answer: Answer) {
  answer.hasBeenPicked = true;
}

async function onCorrectAnswerClick() {
  if (answers.value.answers.filter((a) => a.hasBeenPicked).length === 1) {
    await gameStore.addOnePoint();
    showPlusOne.value = true;
  }
  await new Promise((r) => setTimeout(r, 1700));
  completed.value = true;
}

function onNextClick() {
  if (answers.value.answers.find((a) => a.hasBeenPicked && !a.isCorrectAnswer)) {
    whichDepartmentStore.recyclePerson(person);
  } else {
    whichDepartmentStore.removePerson(person);
  }
  gameStore.next();
}
</script>

<template>
  <WhichDepartmentView :person="person" :answers="answers" :completed="completed" :show-plus-one="showPlusOne" @onAnswerClick="onAnswerClick" @onCorrectAnswerClick="onCorrectAnswerClick" @onNextClick="onNextClick" />
</template>
